--[[
Squire3 - One-click smart mounting.
(c) 2014 Adirelle (adirelle@gmail.com)

This file is part of Squire3.

Squire3 is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Squire3 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Squire3.  If not, see <http://www.gnu.org/licenses/>.
--]]

local addonName, addon = ...

local function isA(class) return select(2, UnitClass("player")) == class end
---[===[@debug@
isA = function() return true end
---@end-debug@]===]

if "Worgen" == select(2, UnitRace("player")) then
	addon:RegisterSpecialSpells(
		87840, "[outdoors,nocombat]", 100, nil, nil -- Running Wild
	)
end

addon:RegisterSpecialMounts(
	75207 -- Abyssal Seahorse
)

if isA("DEATHKNIGHT") then
	addon:RegisterSpecialMounts(
		48778, -- Acherus Deathcharger
		54729  -- Winged Steed of the Ebon Blade
	)
end

if isA("DRUID") then
	addon:RegisterCancelSpells(
		   768, "form", -- Cat form
		   783, "form", -- Travel form
		  5487, "form", -- Bear form
		 24858, "form", -- Moonkin form
		114282, "auraform", -- Treant form, detected by form but cancelled like an aura
		165962, "form"  -- Flight form
	)
	addon:RegisterSpecialSpells(
		-- Note: order matters when moving, e.g. first match wins
		   783, "[swimming,outdoors]",                   nil, nil,  85, -- Swimming travel form
		   783, "[noflyable,outdoors][combat,outdoors]",  40, nil, nil, -- Ground travel form
		165962, "[flyable,nocombat,outdoors]",            98, 310, nil, -- Flight form
		   783, "[flyable,nocombat,outdoors]",            98, 308, nil, -- Flying travel form
		   768, "",                                       30, nil, nil  -- Cat form
	)
end

if isA("HUNTER") then
	addon:RegisterSpecialSpells(
		5118, "", 30, nil, nil -- Aspect of the Cheetah
	)
end

if isA("MONK") then
	addon:RegisterCancelSpells(
		125883, "aura" -- Zen Flight
	)
	addon:RegisterSpecialSpells(
		125883, "[nocombat,outdoors,flyable]", nil, 54, nil, -- Zen Flight
		109132, "", 10, nil, nil, -- Roll
		121827, "", 10, nil, nil  -- Celerity Roll
	)
end

if isA("PALADIN") then
	addon:RegisterSpecialMounts(
		13819, -- Warhorse
		34769, -- Thalassian Warhorse
		73629, -- Exarch's Elekk
		69820, -- Sunwalker Kodo
		23214, -- Charger
		34767, -- Thalassian Charger
		73630, -- Great Exarch's Elekk
		69826, -- Great Sunwalker Kodo
		66906  -- Argent Charger
	)
end

if isA("PRIEST") then
	addon:RegisterCancelSpells(
		15473, "form" -- Shadowform
	)
end

if isA("SHAMAN") then
	addon:RegisterCancelSpells(
		2645, "aura" -- Ghost Wolf
	)
	addon:RegisterSpecialSpells(
		2645, "", 30, nil, nil -- Ghost Wolf
	)
end

if isA("WARLOCK") then
	addon:RegisterSpecialMounts(
		 5784, -- Felsteed
		23161  --Dreadsteed
	)
end
